import Joi from 'joi';
import { Ability } from '@casl/ability';
import { Algorithm, AuthBaseToken } from './auth-base-token';
import { BaseIdToken } from './auth-type';
export declare type IdToken = BaseIdToken & {
    ability: Ability;
};
export declare type AuthIdTokenClaim = BaseIdToken & {
    uuid: string;
};
export declare const schemaAuthIdTokenClaim: {
    uuid: Joi.StringSchema;
    userId: Joi.NumberSchema;
    userName: Joi.StringSchema;
    localeCode: Joi.StringSchema;
    appDomain: Joi.StringSchema;
    productId: Joi.NumberSchema;
};
export declare class AuthIdToken extends AuthBaseToken<AuthIdTokenClaim> {
    private static self;
    private constructor();
    static init(secret: string, expiresIn: string | number, algorithm?: Algorithm): typeof AuthIdToken;
    static term(): void;
    static get instance(): AuthIdToken;
    static get isEnabled(): boolean;
    get expiresIn(): string | number;
}
