import Joi from 'joi';
import { PackRule } from '@casl/ability/extra';
import { AppDomain, BaseIdToken } from './auth-type';
export declare const _rules: Joi.AlternativesSchema;
export declare type VerifyIdToken = BaseIdToken & {
    rules?: PackRule<any>[];
};
export declare const schemaVerifyIdToken: {
    rules: Joi.AlternativesSchema;
    userId: Joi.NumberSchema;
    userName: Joi.StringSchema;
    localeCode: Joi.StringSchema;
    appDomain: Joi.StringSchema;
    productId: Joi.NumberSchema;
};
export declare type AuthBearerVerify = (token: string) => Promise<VerifyIdToken>;
export declare type BasicMetadata = {
    username: string;
    password: string;
    appDomain?: AppDomain;
};
export declare type AuthBasicVerify = (params: BasicMetadata) => Promise<VerifyIdToken>;
