"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAbilityFromPackedRules = exports.generateAbility = exports.schemaBaseIdToken = exports.AppDomain = exports.AuthTokenType = void 0;
const joi_1 = __importDefault(require("joi"));
const ability_1 = require("@casl/ability");
const extra_1 = require("@casl/ability/extra");
var AuthTokenType;
(function (AuthTokenType) {
    AuthTokenType["Bearer"] = "Bearer";
    AuthTokenType["Basic"] = "Basic";
})(AuthTokenType = exports.AuthTokenType || (exports.AuthTokenType = {}));
var AppDomain;
(function (AppDomain) {
    AppDomain["MERCHANT"] = "MERCHANT";
    AppDomain["CONSUMER"] = "CONSUMER";
    AppDomain["ADMIN"] = "ADMIN";
    AppDomain["ROUTER"] = "ROUTER";
})(AppDomain = exports.AppDomain || (exports.AppDomain = {}));
const _id = joi_1.default.number();
const _appDomain = joi_1.default.string()
    .trim()
    .valid(...Object.values(AppDomain));
const _userName = joi_1.default.string().max(250);
const _localeCode = joi_1.default.string().max(10);
exports.schemaBaseIdToken = {
    userId: _id.required(),
    userName: _userName.required(),
    localeCode: _localeCode.required(),
    appDomain: _appDomain.allow(null),
    productId: _id.allow(null)
};
function generateAbility(rules) {
    const ability = new ability_1.Ability();
    if (0 < rules?.length) {
        ability.update(rules);
    }
    return ability;
}
exports.generateAbility = generateAbility;
function generateAbilityFromPackedRules(rules) {
    const ability = new ability_1.Ability();
    if (0 < rules?.length) {
        ability.update((0, extra_1.unpackRules)(rules));
    }
    return ability;
}
exports.generateAbilityFromPackedRules = generateAbilityFromPackedRules;
//# sourceMappingURL=auth-type.js.map