"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.authBearerTokenMiddleware = void 0;
const auth_1 = require("../auth");
const http_auth_1 = require("./http-auth");
function authBearerTokenMiddleware(req, res, next) {
    const token = req.get('authorization');
    if (token && token.startsWith('Bearer ')) {
        const ability = (0, auth_1.generateAbility)();
        const authToken = (0, http_auth_1.getAuthToken)(req) || { type: null, info: { token: null, ability } };
        authToken.type = auth_1.AuthTokenType.Bearer;
        authToken.info.token = token;
        authToken.info.ability = ability;
        (0, http_auth_1.setAuthToken)(req, authToken);
    }
    return next();
}
exports.authBearerTokenMiddleware = authBearerTokenMiddleware;
//# sourceMappingURL=http-auth-bearer.js.map